#include "myvga.h"
#include <stdio.h>
#include <string.h>

int num_lines;

#ifdef DJDIR
BITMAP *allegro_struct_buffer;
#endif

void my_vga_setmode(int mode) {
	num_lines = 0;
#ifndef DJDIR
	vga_init();
	vga_setmode(mode);
	gl_setcontextvga(mode);
//      vga_setmodeX();
//	vga_setlinearaddressing();
//	vga_screenon();
	
	vga_clear();
#else
	allegro_init();
        install_keyboard();
        set_color_depth(8);
        set_gfx_mode(GFX_AUTODETECT, 320, 200, 320, 200);
	allegro_struct_buffer = new BITMAP;
	allegro_struct_buffer->line = (unsigned char **) malloc (
		sizeof (unsigned char *) * 200);
#endif

}

void my_vga_setpalette(int a, int b, int c, int d)
{
#ifdef DJDIR
	RGB p;
	
	p.r = b;
	p.g = c;
	p.b = d;
	set_color(a, &p); 
#else

	vga_setpalette(a, b, c, d);
#endif
}

void my_vga_drawline(int  a ,int  b,int  c,int  d, int color)
{
	num_lines++;
#ifndef DJDIR
	vga_setcolor(color);
       	vga_drawline( a , b, c, d);
#else
       line(screen, a, b, c, d, color);
#endif
}

void my_vga_setcolor(int a)
{
#ifndef DJDIR
	vga_setcolor(a);
#endif
}

void my_vga_clear()
{
#ifndef DJDIR
       vga_clear();
#else
       clear(screen);
#endif
}

char my_vga_getkey() {
#ifndef DJDIR
       return vga_getkey();
#else
       if (keypressed())
             return(readkey() & 0xff);
       else
             return 0x0;
#endif
}

void my_vga_setmode_TEXT()
{
	printf("Number of lines: %d ", num_lines);
#ifndef DJDIR
	vga_setmode(TEXT);
#else
        allegro_exit();
#endif
}

void my_vga_dumpscreen()
{
#ifdef DJDIR

BITMAP *bmp;
PALETTE pal;

	// dump screen to pcx file called "dump.pcx"
	get_palette(pal);
	bmp = create_sub_bitmap(screen, 0, 0, SCREEN_W, SCREEN_H);
	save_bitmap("dump.pcx", bmp, pal);
	destroy_bitmap(bmp);

#endif
}

void my_vga_blitscreen(unsigned char *buff, int xres, int yres)
{
	int y;
#ifdef DJDIR
	for (y = 0; y < yres ; y++)
	    allegro_struct_buffer->line[y] = buff + xres * y;
	blit(allegro_struct_buffer, screen,
		0, 0, 0, 0, xres, yres);
#else
	memcpy(VBUF, buff, xres * yres); // svgalib hack pointer
#endif
}

void my_vga_clearbuffer(unsigned char *buff, int xres, int yres) {
	memset(buff, 0, xres * yres);
}
