#include <stdio.h>
#include <math.h>
#include <strings.h>
#include "slist.h"
#include "skel.h"
#include "myvga.h"
#include "grfont.h"

#ifdef X86
#include <vga.h>
#endif


#define SOLID_BUFSIZE 1024

void read_demo (char *buf)
{
	FILE *demofile;

	if ( (demofile = fopen("demoreel.keys", "r")) == NULL)
		buf = "";
	else
	   fscanf(demofile, "%s", buf);
	fclose(demofile);
}

void write_demo (char *buf)
{
	FILE *demofile;

	if ((demofile = fopen("demoreel.keys", "w")) != NULL) {
	   	fprintf(demofile, "%s\n", buf);
		fclose(demofile);
	}
}



/*  In this test, I test a dumb approach to drawing every pixel on a low
        resolution screen.  In this case, 320x200, 8 bitplanes
*/
void draw_solid(sl_screen *myscreen, camera *cam, simple_triangle_list *stl, simple_point_list *spl)
{
        int x1, y1, x2, y2, x3, y3, t;
	real theta, velocity, accel;
	char c, action;
	v3 trans;
	d2 ta, tb, tc;
	int xres, yres, xres_1, yres_1;
	char buffer[SOLID_BUFSIZE];
	char grstat[40];
	int buffer_size, buffer_index, frames ;
	bool demo_mode;
	graphfont twelve, eight, seven, italics;

	simple_point_list *p_list;
	simple_triangle_list *tri_list;

	buffer_size = 0;
	demo_mode = false;

        printf("hello, world\n");

	twelve.initfont("fonts/font12.pbm");
	eight.initfont("fonts/font8.pbm");
	seven.initfont("fonts/font7.pbm");
	italics.initfont("fonts/italics.pbm");

	xres = cam->xres;
	yres = cam->yres;
	velocity = 0.0;
	accel = 0.1;

	xres_1 = xres - 1;
	yres_1 = yres - 1;
	
        theta = 0.0;
	frames = 0;
        c = ' ';
        while ( c  != 'q')
        {
		frames++;
		action = 'y';
                switch (c) {
                //case '8': cam->position = cam->position + 
                 //       v3_scalar_mul(0.9, cam->forward);
                  //      break;
                //case '2': cam->position = cam->position - 
                        //v3_scalar_mul(0.9, cam->forward);
                        //break;
                case '8': velocity += accel;
                        break;
                case '2': velocity -= accel;
                        break;
                case '1': theta += 0.1;
                        cam->up = cam->up -
                                v3_scalar_mul(0.1, cam->fxu);
                        break;
                case '3': theta -= 0.1;
                        cam->up = cam->up +
                                v3_scalar_mul(0.1, cam->fxu);
                        break;
                case '4': theta += 0.1;
                        cam->forward = cam->forward -
                                v3_scalar_mul(0.01, cam->fxu);
                        break;
                case '5': velocity = 0;
                        break;
                case '6': theta -= 0.1;
                        cam->forward = cam->forward +
                                v3_scalar_mul(0.01, cam->fxu);
                        break;
                case 'a': cam->position = cam->position + 
                                v3_scalar_mul(0.3, cam->up);
                        break;
                case 'z': cam->position = cam->position - 
                                v3_scalar_mul(0.3, cam->up);
                        break;
                case 's': cam->forward = cam->forward + 
                                v3_scalar_mul(0.01, cam->up);
                        break;
                case 'x': cam->forward = cam->forward - 
                                v3_scalar_mul(0.01, cam->up);
                        break;
                case 'r': read_demo(buffer);
			  demo_mode = true;
			  buffer_index = 0;
			  action = 'n';
                        break;
                case 'w': buffer[buffer_size] = (char) NULL;
			  write_demo(buffer);
			  action = 'n';
                        break;
                case ' ': my_vga_dumpscreen();
                        break;
                default:  
			 action = 'n';
                         break;
                }
		if ( (demo_mode == false) && (action == 'y')) {
			if (buffer_size > SOLID_BUFSIZE)
				buffer_size = 0;
			buffer[buffer_size++] = c;
		}

                // cam->position.x = sin(theta) * 9.0;
                // cam->position.z = - cos(theta) * 9.0;
                cam->make_m3();

                cam->position = cam->position + 
                        v3_scalar_mul(velocity, cam->forward);

		// transform triangle's points in world coordinates
		// into camera coordinates (trans). 
                // Then project onto film: 3d->2d (proj).

                p_list = spl;
		while (p_list != NULL)
		{
                        // trans = p_list->p->pt;
                        cam->cam_trans(&p_list->p->pt, p_list->p->trans);
			if (p_list->p->trans->z > 0.5) {
                                cam->cam_proj(p_list->p->trans,
					&p_list->p->project );
				p_list->p->drawable = 'y';
			}
			else
			{
				cam->cam_proj(p_list->p->trans,
					&p_list->p->project );
				p_list->p->drawable = 'n';
			}
			p_list = p_list->next;
		} 
		
		// draw projected triangles
		tri_list = stl;
		//if (action == 'y') {
		if (1) {
			while (tri_list != NULL)
			{
				if (v3_dot(tri_list->tri->normal, cam->forward) > 0.0) 
				;
				{
					get_scanlines(myscreen, tri_list->tri, xres_1, yres_1);
				} // if dot prod.
				tri_list = tri_list->next;
	
			} // while triangles 
                        endpoint_sort(myscreen);
			//my_vga_clear();
			//myscreen->draw_sorted();  // hack, just gets unsorted
			// render here
			myscreen->draw_buffer(cam);
			//sprintf(grstat, "l: %10d", myscreen->sl_used_count);
			//myfont->printgraphbuf(cam->buffer, cam->xres, cam->yres,
			//			0, 0, grstat, (char) 199);
			twelve.printgraphbuf(cam->buffer, cam->xres, cam->yres,
					1, 1, "Slist", (char) ( sin ((float) frames / 30.0) * 125 + 128));
			eight.printgraphbuf(cam->buffer, cam->xres, cam->yres,
					100, 1, "Slist", (char) ( sin ((float) frames / 30.0) * 125 + 128));
                	sprintf(grstat, "Velocity: %6.2f",velocity);
			seven.printgraphbuf(cam->buffer, cam->xres, cam->yres,
					210, 0, grstat, (char) ( sin ((float) frames / 30.0) * 125 + 128));
                	sprintf(grstat, "Cam: x(%6.2f) y(%6.2f) z(%6.2f)",cam->position.x, cam->position.y, cam->position.z);
			italics.printgraphbuf(cam->buffer, cam->xres, cam->yres,
					0, 184, grstat, (char) ( sin ( (float) (( frames + 400) / 30.0)) * 125 + 128));
			my_vga_blitscreen(cam->buffer, cam->xres, cam->yres);
			myscreen->free_sorted_sl_nodes();
			my_vga_clearbuffer(cam->buffer, cam->xres, cam->yres);
		} // if action
	   if (demo_mode == false) 
          	c = my_vga_getkey();
	   else
		if ((c = buffer[buffer_index++]) == (char) NULL)
			demo_mode = false;
	} // while not q
	printf("done!\n");
}
