#include <stdio.h>
#include "matrix.h"
#include "spec.h"

camera::make_m3()
{
	forward = forward.unit();
	fxu = v3_cross(forward, up).unit();
	up = v3_cross(fxu, forward).unit();
	
	m = m3(fxu.x, up.x, forward.x,
		fxu.y, up.y, forward.y,
		fxu.z, up.z, forward.z);
	inverse = m.inv();
	m_inv_pos = inverse * position;
}
 
void camera::cam_trans(v3 *p, v3 *result)
{
           
        *result = inverse * *p - m_inv_pos;  
}             

void camera::cam_proj(v3 *p, d2 *result)
{
	if (p->z > 0.1) {
	result->x = (int) ( p->x / p->z * zoom * (float) (xres / 2.0) + xres / 2.0);
	result->y = (int) ( - p->y / p->z * zoom * (float) (yres / 2.0) + yres / 2.0);
	} else {
		if (p->z > 0.0) 
		{
		result->x = (int) (  p->x / (p->z + 0.01) * zoom *  // 500. * 
					(float) (xres / 2.0) + xres / 2.0);
		result->y = (int) ( - p->y / (p->z + 0.01) * zoom *  // 500. * 
					(float) (yres / 2.0) + yres / 2.0);
		} else {
		result->x = (int) (  p->x  * zoom *   500. * 
					(float) (xres / 2.0) + xres / 2.0);
		result->y = (int) ( -  p->y * zoom *  500. * 
					(float) (yres / 2.0) + yres / 2.0);
		}
	}
}
point::point()
{
        trans = new v3;
}

point::print()
{
	printf("o");
	if (label != NULL)
		printf("%14s ", label);
	else
		printf(" NULL ");
 	pt.print();
	printf("o \n");
}

itriangle::print()
{
	printf("|>");
 	a->print();
	b->print();
	c->print();
	printf("<| n: ");
	normal.print();
	printf("\n");
	
}
camera::print()
{
	printf("{{{{Camera pos:");
	position.print();
	printf(" for:");
	forward.print();
	printf(" up:");
	up.print();
	printf(" xres %d yres %d zoom %g\n", xres, yres, zoom);
	m.print();
	printf("\n inv: \n");
	inverse.print();
	printf("transformation and inverse matrices}}}}\n");
}

light::print()
{
	printf("light print stub");
}

simple_triangle_list::print()
{
	if (tri != NULL) 
		tri->print();
	if (next != NULL)
		next->print();
}
	

simple_point_list::print()
{
	if (p != NULL) 
		p->print();
	if (next != NULL)
		next->print();
}
	

